# Ogre::ZipArchive Class Reference

Specialisation of the Archive class to allow reading of files from a zip format source archive. More...

`#include <OgreZip.h>`

Inheritance diagram for Ogre::ZipArchive:

[legend]

List of all members.

## Public Member Functions

| ZipArchive (const String &name, const String &archType)
| ~ZipArchive ()
bool | isCaseSensitive (void) const
| Returns whether this archive is case sensitive in the way it matches files.
void | load ()

Loads the archive.

Remarks:
  This initializes all the internal data of the class.

Warning:
  Do not call this function directly, it is meant to be used only by the ArchiveManager class.

void | unload ()

Unloads the archive.

Warning:
  Do not call this function directly, it is meant to be used only by the ArchiveManager class.

DataStreamPtr | open (const String &filename) const

Open a stream on a given file.

Note:
  There is no equivalent 'close' method; the returned stream controls the lifecycle of this file operation.

Parameters:

  | filename | The fully qualified name of the file

Returns:
  A shared pointer to a DataStream which can be used to read / write the file. If the file is not present, returns a null shared pointer.

StringVectorPtr | list (bool recursive=true, bool dirs=false)

List all file names in the archive.

Note:
  This method only returns filenames, you can also retrieve other information using listFileInfo.

Parameters:

  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of filenames matching the criteria, all are fully qualified

FileInfoListPtr | listFileInfo (bool recursive=true, bool dirs=false)

List all files in the archive with accompanying information.

Parameters:

  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of structures detailing quite a lot of information about all the files in the archive.

StringVectorPtr | find (const String &pattern, bool recursive=true, bool dirs=false)

Find all file or directory names matching a given pattern in this archive.

Note:
  This method only returns filenames, you can also retrieve other information using findFileInfo.

Parameters:

  | pattern | The pattern to search for; wildcards (*) are allowed
  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of filenames matching the criteria, all are fully qualified

FileInfoListPtr | findFileInfo (const String &pattern, bool recursive=true, bool dirs=false)

Find all files or directories matching a given pattern in this archive and get some detailed information about them.

Parameters:

  | pattern | The pattern to search for; wildcards (*) are allowed
  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of file information structures for all files matching the criteria.

bool | exists (const String &filename)
| Find out if the named file exists (note: fully qualified filename required).
time_t | getModifiedTime (const String &filename)
| Retrieve the modification time of a given file.
const String & | getName (void) const
| Get the name of this archive.
const String & | getType (void) const
| Return the type code of this Archive.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Protected Member Functions

void | checkZzipError (int zzipError, const String &operation) const
| Handle any errors from zzip.

## Protected Attributes

ZZIP_DIR * | mZzipDir
| Handle to root zip file.
FileInfoList | mFileList
| File list (since zziplib seems to only allow scanning of dir tree once).
String | mName
| Archive name.
String | mType
| Archive type code.

## Detailed Description

Specialisation of the Archive class to allow reading of files from a zip format source archive.

Remarks:
  This archive format supports all archives compressed in the standard zip format, including iD pk3 files.

Definition at line 49 of file OgreZip.h.

## Constructor & Destructor Documentation

Ogre::ZipArchive::ZipArchive | ( | const String & | name,
|  | const String & | archType |
| ) |  |  |

Ogre::ZipArchive::~ZipArchive | ( |  | ) |

## Member Function Documentation

void Ogre::ZipArchive::checkZzipError | ( | int | zzipError,
|  | const String & | operation |
| ) |  |  | const`[protected]`

Handle any errors from zzip.

bool Ogre::ZipArchive::isCaseSensitive | ( | void |  | ) | const`[virtual]`

Returns whether this archive is case sensitive in the way it matches files.

Implements Ogre::Archive.

Definition at line 62 of file OgreZip.h.

void Ogre::ZipArchive::load | ( |  | ) | `[virtual]`

Loads the archive.

Remarks:
  This initializes all the internal data of the class.

Warning:
  Do not call this function directly, it is meant to be used only by the ArchiveManager class.

Implements Ogre::Archive.

void Ogre::ZipArchive::unload | ( |  | ) | `[virtual]`

Unloads the archive.

Warning:
  Do not call this function directly, it is meant to be used only by the ArchiveManager class.

Implements Ogre::Archive.

DataStreamPtr Ogre::ZipArchive::open | ( | const String & | filename | ) | const`[virtual]`

Open a stream on a given file.

Note:
  There is no equivalent 'close' method; the returned stream controls the lifecycle of this file operation.

Parameters:

  | filename | The fully qualified name of the file

Returns:
  A shared pointer to a DataStream which can be used to read / write the file. If the file is not present, returns a null shared pointer.

Implements Ogre::Archive.

StringVectorPtr Ogre::ZipArchive::list | ( | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[virtual]`

List all file names in the archive.

Note:
  This method only returns filenames, you can also retrieve other information using listFileInfo.

Parameters:

  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of filenames matching the criteria, all are fully qualified

Implements Ogre::Archive.

FileInfoListPtr Ogre::ZipArchive::listFileInfo | ( | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[virtual]`

List all files in the archive with accompanying information.

Parameters:

  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of structures detailing quite a lot of information about all the files in the archive.

Implements Ogre::Archive.

StringVectorPtr Ogre::ZipArchive::find | ( | const String & | pattern,
|  | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[virtual]`

Find all file or directory names matching a given pattern in this archive.

Note:
  This method only returns filenames, you can also retrieve other information using findFileInfo.

Parameters:

  | pattern | The pattern to search for; wildcards (*) are allowed
  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of filenames matching the criteria, all are fully qualified

Implements Ogre::Archive.

FileInfoListPtr Ogre::ZipArchive::findFileInfo | ( | const String & | pattern,
|  | bool | recursive = `true`,
|  | bool | dirs = `false` |
| ) |  |  | `[virtual]`

Find all files or directories matching a given pattern in this archive and get some detailed information about them.

Parameters:

  | pattern | The pattern to search for; wildcards (*) are allowed
  | recursive | Whether all paths of the archive are searched (if the archive has a concept of that)
  | dirs | Set to true if you want the directories to be listed instead of files

Returns:
  A list of file information structures for all files matching the criteria.

Implements Ogre::Archive.

bool Ogre::ZipArchive::exists | ( | const String & | filename | ) | `[virtual]`

Find out if the named file exists (note: fully qualified filename required).

Implements Ogre::Archive.

time_t Ogre::ZipArchive::getModifiedTime | ( | const String & | filename | ) | `[virtual]`

Retrieve the modification time of a given file.

Implements Ogre::Archive.

const String& Ogre::Archive::getName | ( | void |  | ) | const`[inherited]`

Get the name of this archive.

Definition at line 101 of file OgreArchive.h.

const String& Ogre::Archive::getType | ( | void |  | ) | const`[inherited]`

Return the type code of this Archive.

Definition at line 191 of file OgreArchive.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

ZZIP_DIR* Ogre::ZipArchive::mZzipDir `[protected]`

Handle to root zip file.

Definition at line 53 of file OgreZip.h.

FileInfoList Ogre::ZipArchive::mFileList `[protected]`

File list (since zziplib seems to only allow scanning of dir tree once).

Definition at line 57 of file OgreZip.h.

String Ogre::Archive::mName `[protected, inherited]`

Archive name.

Definition at line 85 of file OgreArchive.h.

String Ogre::Archive::mType `[protected, inherited]`

Archive type code.

Definition at line 87 of file OgreArchive.h.

The documentation for this class was generated from the following file:

- OgreZip.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:38:27 2009